<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "idp_provision_condition".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "IdpProvisionCondition".
 *
 * Columns in table "idp_provision_condition" available as properties of the model,
 * followed by relations of table "idp_provision_condition" available as properties of the model.
 *
 * @property integer $id
 * @property string $name
 * @property string $date_added
 * @property string $query_condition
 * @property string $failed_condition_message
 *
 * @property IdpProvisionOperationCondition[] $idpProvisionOperationConditions
 */
abstract class BaseIdpProvisionCondition extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'idp_provision_condition';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'IdpProvisionCondition|IdpProvisionConditions', $n);
    }

    public static function representingColumn()
    {
        return 'date_added';
    }

    public function rules()
    {
        return array(
            array('date_added', 'required'),
            array('name', 'length', 'max'=>100),
            array('query_condition, failed_condition_message', 'safe'),
            array('name, query_condition, failed_condition_message', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, name, date_added, query_condition, failed_condition_message', 'safe', 'on'=>'search'),
        );
    }

    public function relations()
    {
        return array(
            'idpProvisionOperationConditions' => array(self::HAS_MANY, 'IdpProvisionOperationCondition', 'idp_provision_condition_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'name' => Yii::t('app', 'Name'),
            'date_added' => Yii::t('app', 'Date Added'),
            'query_condition' => Yii::t('app', 'Query Condition'),
            'failed_condition_message' => Yii::t('app', 'Failed Condition Message'),
            'idpProvisionOperationConditions' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('name', $this->name, true);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('query_condition', $this->query_condition, true);
        $criteria->compare('failed_condition_message', $this->failed_condition_message, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }

}
